new Vue({
    el: '#activityDetail',
    data() {
        return {
            userInfo: {},
            ruleForm: {
                hb_hzdw: '',
                hb_zzxm: '',
                hb_lxfs: '',
                hb_hdlx: [],
                hb_title: '',
                hb_content: ''
            },
            rules: {
                hb_hzdw: [
                    {required: true, message: '请输入作者单位', trigger: 'blur'}
                ],
                hb_zzxm: [
                    {required: true, message: '请输入作者姓名', trigger: 'blur'}
                ],
                hb_lxfs: [
                    {required: true, message: '请输入联系方式', trigger: 'blur'}
                ],
                hb_title: [
                    {required: true, message: '请输入题目', trigger: 'blur'}
                ],
                hb_hdlx: [
                    {type: 'array', required: true, message: '请至少选择一个类型', trigger: 'change'}
                ],
            },
            fullscreenLoading: false,
            typeTree: [],
            checkList: [],
            radio: 9,
            type: '',
            id: '',
            hdgg: {},
            tzgg: {},
            yxzp: {},
            fileList: [],
            hdgl: {},
            uploadInfo: [],
            voteInfo:{},
            voteList:[]
        }
    },
    methods: {
        getAcNoticeDetail() {
            let data = {
                token: this.userInfo.token,
                hh_id: this.id
            }
            axios_get(link.hdgg_detail, data).then(res => {
                if (res.data.code == 1) {
                    this.hdgg = res.data.data.one_info;
                    if (this.hdgg.hh_img != '') {
                        this.hdgg.hh_img = globalData.login + '/' + this.hdgg.hh_img;
                    }
                }
            });
        },
        getNoticeDetail() {
            let data = {
                token: this.userInfo.token,
                hz_id: this.id
            }
            axios_get(link.tzgg_detail, data).then(res => {
                if (res.data.code == 1) {
                    this.tzgg = res.data.data.one_info;
                }
            });
        },
        getWorksDetail() {
            let data = {
                token: this.userInfo.token,
                hy_id: this.id
            }
            axios_get(link.works_detail, data).then(res => {
                this.fileList = [];
                if (res.data.code == 1) {
                    this.yxzp = res.data.data.one_info;
                    if (this.yxzp.hy_img != '') {
                        this.yxzp.hy_img = globalData.login + '/' + this.yxzp.hy_img;
                    }
                    if (this.yxzp.hy_hdfj != '') {
                        let file_list = this.yxzp.hy_hdfj.split(';');
                        for (let i in file_list) {
                            let info = {
                                link: file_list[i].split('|')[0],
                                title: file_list[i].split('|')[1]
                            };
                            if (!info.link.includes('http')) {
                                info.link = globalData.login + '/' + info.link
                            }
                            this.fileList.push(info)
                        }
                    }

                }
            });
        },
        getAcDetail() {
            let data = {
                token: this.userInfo.token,
                hhg_id: this.id
            }
            axios_get(link.ac_detail, data).then(res => {
                this.fileList = [];
                if (res.data.code == 1) {
                    this.hdgl = res.data.data.one_info;
                    if (this.hdgl.hhg_img && this.hdgl.hhg_img != '') {
                        this.hdgl.hhg_img = globalData.login + '/' + this.hdgl.hhg_img;
                    }
                    if (this.hdgl.hhg_files && this.hdgl.hhg_files != '') {
                        let file_list = this.hdgl.hhg_files.split(';');
                        for (let i in file_list) {
                            let info = {
                                link: file_list[i].split('|')[0],
                                title: file_list[i].split('|')[1]
                            };
                            if (!info.link.includes('http')) {
                                info.link = globalData.login + '/' + info.link
                            }
                            this.fileList.push(info)
                        }
                    }
                    if(this.hdgl.bmxx.hb_id) {
                        this.ruleForm.hb_hzdw = this.hdgl.bmxx.hb_hzdw;
                        this.ruleForm.hb_zzxm = this.hdgl.bmxx.hb_zzxm;
                        this.ruleForm.hb_lxfs = this.hdgl.bmxx.hb_lxfs;
                        this.ruleForm.hb_hdlx = this.hdgl.bmxx.hb_hdlx.split(',');
                        this.ruleForm.hb_title = this.hdgl.bmxx.hb_title;
                        tinymce.init({
                            selector: '#content',
                            plugins: 'print preview searchreplace autolink directionality visualblocks visualchars fullscreen image link media template code codesample table charmap hr pagebreak nonbreaking anchor insertdatetime advlist lists imagetools textpattern help autosave',
                            toolbar: 'fontselect fontsizeselect styleselect forecolor backcolor bold italic underline strikethrough alignleft aligncenter alignright  bullist numlist code blockquote subscript superscript removeformat charmap hr table image  pagebreak',
                            fontsize_formats: '8px 10px 12px 14px 16px 18px 24px 36px 48px 56px 72px',
                            font_formats:"微软雅黑='微软雅黑';宋体='宋体';黑体='黑体';仿宋='仿宋';楷体='楷体';隶书='隶书';幼圆='幼圆';Andale Mono=andale mono,times;Arial=arial,helvetica,sans-serif;Arial Black=arial black,avant garde;Book Antiqua=book antiqua,palatino;Comic Sans MS=comic sans ms,sans-serif;Courier New=courier new,courier;Georgia=georgia,palatino;Helvetica=helvetica;Impact=impact,chicago;Symbol=symbol;Tahoma=tahoma,arial,helvetica,sans-serif;Terminal=terminal,monaco;Times New Roman=times new roman,times;Trebuchet MS=trebuchet ms,geneva;Verdana=verdana,geneva;Webdings=webdings;Wingdings=wingdings",
                            autosave_ask_before_unload: false,
                            toolbar_drawer: false,
                            language_url: '/lib/tinymce/langs/zh_CN.js',
                            language: 'zh_CN',//注意大小写
                            menubar: false,
                            convert_urls: false,
                            resize: true,
                            style_formats_autohide: true,
                            branding: false,
                            elementpath: false,
                            images_upload_handler: (blobInfo, success, fail) => {
                                var xhr, formData;
                                xhr = new XMLHttpRequest();
                                xhr.withCredentials = false;
                                xhr.open('POST', globalData.login + '/upload/main/file');
                                formData = new FormData();
                                formData.append('filedata', blobInfo.blob(), blobInfo.filename());
                                formData.append('api', 'json');
                                formData.append('urltype', '2');
                                formData.append("token",this.userInfo.token);
                                xhr.send(formData);
                                xhr.onload = function() {
                                    var json;
                                    if (xhr.status != 200) {
                                        fail('HTTP Error: ' + xhr.status);
                                        return;
                                    }
                                    json = JSON.parse(xhr.responseText);
                                    var imgUrl = globalData.login + '/' + json.data.url
                                    // if (!json || typeof json.location != 'string') {
                                    //     fail('Invalid JSON: ' + xhr.responseText);
                                    //     return;
                                    // }
                                    success(imgUrl);
                                };

                            },
                            init_instance_callback: (editor) => {
                                tinyMCE.editors['content'].setContent(this.hdgl.bmxx.hb_content);
                            },
                        });

                        if(this.hdgl.bmxx.hb_files && this.hdgl.bmxx.hb_files != '') {
                            this.uploadInfo = [];
                            let file_list = this.hdgl.bmxx.hb_files.split(';');
                            for (let i in file_list) {
                                let info = {
                                    link: file_list[i].split('|')[0],
                                    title: file_list[i].split('|')[1]
                                };
                                this.uploadInfo.push(info)
                            }
                        }

                    } else {
                        tinymce.init({
                            selector: '#content',
                            plugins: 'print preview searchreplace autolink directionality visualblocks visualchars fullscreen image link media template code codesample table charmap hr pagebreak nonbreaking anchor insertdatetime advlist lists imagetools textpattern help autosave',
                            toolbar: 'fontselect fontsizeselect styleselect forecolor backcolor bold italic underline strikethrough alignleft aligncenter alignright  bullist numlist code blockquote subscript superscript removeformat charmap hr table image  pagebreak',
                            fontsize_formats: '8px 10px 12px 14px 16px 18px 24px 36px 48px 56px 72px',
                            font_formats:"微软雅黑='微软雅黑';宋体='宋体';黑体='黑体';仿宋='仿宋';楷体='楷体';隶书='隶书';幼圆='幼圆';Andale Mono=andale mono,times;Arial=arial,helvetica,sans-serif;Arial Black=arial black,avant garde;Book Antiqua=book antiqua,palatino;Comic Sans MS=comic sans ms,sans-serif;Courier New=courier new,courier;Georgia=georgia,palatino;Helvetica=helvetica;Impact=impact,chicago;Symbol=symbol;Tahoma=tahoma,arial,helvetica,sans-serif;Terminal=terminal,monaco;Times New Roman=times new roman,times;Trebuchet MS=trebuchet ms,geneva;Verdana=verdana,geneva;Webdings=webdings;Wingdings=wingdings",
                            autosave_ask_before_unload: false,
                            toolbar_drawer: false,
                            language_url: '/lib/tinymce/langs/zh_CN.js',
                            language: 'zh_CN',//注意大小写
                            menubar: false,
                            convert_urls: false,
                            resize: true,
                            style_formats_autohide: true,
                            branding: false,
                            elementpath: false,
                            images_upload_handler: (blobInfo, success, fail) => {
                                var xhr, formData;
                                xhr = new XMLHttpRequest();
                                xhr.withCredentials = false;
                                xhr.open('POST', globalData.login + '/upload/main/file');
                                formData = new FormData();
                                formData.append('filedata', blobInfo.blob(), blobInfo.filename());
                                formData.append('api', 'json');
                                formData.append('urltype', '2');
                                formData.append("token",this.userInfo.token);
                                xhr.send(formData);
                                xhr.onload = function() {
                                    var json;
                                    if (xhr.status != 200) {
                                        fail('HTTP Error: ' + xhr.status);
                                        return;
                                    }
                                    json = JSON.parse(xhr.responseText);
                                    var imgUrl = globalData.login + '/' + json.data.url
                                    // if (!json || typeof json.location != 'string') {
                                    //     fail('Invalid JSON: ' + xhr.responseText);
                                    //     return;
                                    // }
                                    success(imgUrl);
                                };

                            }
                        });
                    }

                }
            });
        },
        getAcTypeTree() {
            let data = {
                token: this.userInfo.token
            }
            axios_get(link.type_tree, data).then(res => {
                if (res.data.code == 1) {
                    this.typeTree = res.data.data.one_info;
                }
            })
        },
        getVoteDetail() {
            let data = {
                token: this.userInfo.token,
                hw_id: this.id
            }
            axios_get(link.vote_detail, data).then(res => {
                if(res.data.code == 1) {
                    this.voteInfo = res.data.data.one_info;
                    this.voteList = JSON.parse(res.data.data.one_info.hw_content);
                    console.log(this.voteList,89)
                    for(let i in this.voteList) {
                        if(this.voteList[i].type == 'radio') {
                            this.$set(this.voteList[i],'result', '');
                        } else if(this.voteList[i].type == 'checkbox') {
                            this.$set(this.voteList[i],'result', []);
                        }

                    }
                }
            })
        },
        // 添加文件
        addFile() {
            let fileList = [...document.getElementById('addFile').files];
            let temp = [];
            if (fileList.length > 20) {
                this.$message({
                    message: '一次上传文件数量不能超过20！',
                    type: 'warning',
                    showClose: true,
                    duration: '1500',
                });
                fileList = [];
            } else {
                this.fullscreenLoading = true;
                for (let i in fileList) {
                    if (fileList[i].size > 5 * 1024 * 1024) {
                        this.$message({
                            message: '单个文件大小不能超过5M!',
                            type: 'warning',
                            showClose: true,
                            duration: '1500',
                        });
                        fileList = [];
                        return false;
                    }

                    let formData = new FormData();
                    formData.append("filedata", fileList[i]);
                    formData.append('api', 'json');
                    formData.append('urltype', '2');
                    formData.append("token", this.userInfo.token);
                    $.ajax({
                        url: globalData.login + '/upload/main/file',
                        type: 'POST',
                        dataType: 'json',
                        timeout: 180000,
                        data: formData,
                        processData: false,
                        contentType: false,
                        success: (res) => {
                            if (res.code == '1') {
                                let u_info = {
                                    title: res.data.file_name,
                                    link: res.data.url
                                }
                                this.uploadInfo.push(u_info);
                                temp.push(res.data);
                                if (temp.length === fileList.length) {
                                    this.fullscreenLoading = false;
                                }
                                document.getElementById('addFile').value = ''
                                console.log(this.uploadInfo, 67)
                            } else {
                                this.fullscreenLoading = false;
                                this.$message({
                                    message: res.msg,
                                    type: 'error',
                                    showClose: true,
                                    duration: '1500',
                                });
                                document.getElementById('addFile').value = '';
                            }
                        }
                    })
                }
            }
        },
        submitForm(formName) {
            this.ruleForm.hb_content = tinyMCE.editors['content'].getContent();
            this.$refs[formName].validate((valid) => {
                if (valid) {
                    let up_list = [];
                    if (this.uploadInfo.length > 0) {
                       for(let i in this.uploadInfo) {
                           let info = this.uploadInfo[i].link + '|' + this.uploadInfo[i].title;
                           up_list.push(info);
                       }
                    }
                    let data = {
                        token: this.userInfo.token,
                        issubmit: '1',
                        hdpb_bmjl: {
                            hhg_id: this.id,
                            hb_hzdw: this.ruleForm.hb_hzdw,
                            hb_zzxm: this.ruleForm.hb_zzxm,
                            hb_lxfs: this.ruleForm.hb_lxfs,
                            hb_hdlx: this.ruleForm.hb_hdlx.join(','),
                            hb_title: this.ruleForm.hb_title,
                            hb_content: this.ruleForm.hb_content
                        }
                    }
                    if(up_list.length > 0) {
                        data.hdpb_bmjl.hb_files = up_list.join(';');
                    } else {
                        data.hdpb_bmjl.hb_files = '';
                    }
                    this.fullscreenLoading = true;
                    if(!this.hdgl.bmxx.hb_id) {
                        axios_post(link.ac_sign_add,data).then(res=>{
                            this.fullscreenLoading = false;
                            if(res.data.code == 1) {
                                this.$message({
                                    message: '报名成功!',
                                    type: 'success',
                                    showClose: true,
                                    duration: '1500',
                                    onClose:()=>{
                                        location.reload();
                                    }
                                });

                            } else {
                                this.$message({
                                    message: res.data.msg,
                                    type: 'error',
                                    showClose: true,
                                    duration: '1500',
                                });
                            }
                        })
                    } else {
                        data.hb_id = this.hdgl.bmxx.hb_id;
                        axios_post(link.ac_sign_edit,data).then(res=>{
                            this.fullscreenLoading = false;
                            if(res.data.code == 1) {
                                this.$message({
                                    message: '报名编辑成功!',
                                    type: 'success',
                                    showClose: true,
                                    duration: '1500',
                                    onClose:()=>{
                                        location.reload();
                                    }
                                });
                            } else {
                                this.$message({
                                    message: res.data.msg,
                                    type: 'error',
                                    showClose: true,
                                    duration: '1500',
                                });
                            }
                        })
                    }

                }
            })
        },
        delFile(index) {
            this.uploadInfo.splice(index,1);
        },
        signTo() {
            let f_t = $('.sign-form').offset().top;
            $('html,body').animate({scrollTop: f_t},1000);
        },
        submitVote() {
            let vote_result = [];
            this.voteList.forEach(item =>{
                if(item.type == 'radio' && item.result != '') {
                    vote_result.push(item.result);
                } else if(item.type == 'checkbox' && item.result.length > 0) {
                    vote_result.push(item.result.join(','));
                }
            })
            if(vote_result.length != this.voteList.length) {
                this.$message({
                    message: '还有题目未选择答案！',
                    type: 'error',
                    showClose: true,
                    duration: '1500',
                });
            } else {
                this.fullscreenLoading = true;
                let data = {
                    token: this.userInfo.token,
                    issubmit:'1',
                    hdpb_wjtp_log:{
                        hw_id: this.id,
                        hwl_tpx: JSON.stringify(vote_result)
                    }
                }
                axios_post(link.vote_add,data).then(res =>{
                    this.fullscreenLoading = false;
                    if(res.data.code == 1) {
                        this.$message({
                            message: '提交成功！',
                            type: 'success',
                            showClose: true,
                            duration: '1500',
                        });
                    } else {
                        this.$message({
                            message: res.data.msg,
                            type: 'error',
                            showClose: true,
                            duration: '1500',
                        });
                    }
                })

            }

        }
    },
    mounted() {
        if (localStorage.getItem('userInfo')) {
            this.userInfo = JSON.parse(localStorage.getItem('userInfo'));
            if (location.search.includes('type')) {
                this.type = location.search.split('&')[0].substring(6);
                this.id = location.search.split('&')[1].substring(3);
                switch (this.type) {
                    case '1':
                        this.getAcNoticeDetail();
                        break;
                    case '2':
                        this.getNoticeDetail();
                        break;
                    case '3':
                        this.getWorksDetail();
                        break;
                    case '4':
                        this.getAcDetail();
                        this.getAcTypeTree();
                        break;
                    case '5':
                    case '6':
                        this.getVoteDetail();
                        break;
                }
            }
        } else {
            window.location.href = '../home/login.html';
        }
    }
})