new Vue({
    el: '#login',
    data() {
        return {
            loginForm: {
                user: '',
                pwd: ''
            },
            fullscreenLoading: false,
            user_id: ''
        }
    },
    methods: {
        login() {
            let data = {
                user_name: this.loginForm.user,
                user_password: this.loginForm.pwd
            }
            this.fullscreenLoading = true;
            axios_post(link.login, data).then((res) => {
                if (res.data.code == 1) {
                    this.fullscreenLoading = false;
                    this.$message({
                        message: '登录成功！',
                        type: 'success',
                        showClose: true,
                        duration: '1000',
                        onClose: () => {
                            localStorage.setItem('userInfo', JSON.stringify(res.data.data));
                            window.location.href = '../home/index.html';
                        }
                    });
                } else {
                    this.fullscreenLoading = false;
                    this.$message({
                        message: res.data.msg,
                        type: 'error',
                        showClose: true,
                        duration: '1000'
                    });
                }
            });
        },
        autoLogin() {
            let data = {
                user_id: this.user_id
            }
            this.fullscreenLoading = true;
            axios_post(link.auto_login, data).then((res) => {
                if (res.data.code == 1) {
                    localStorage.setItem('userInfo', JSON.stringify(res.data.data.one_info));
                    window.location.href = '../home/index.html';
                } else {
                    this.fullscreenLoading = false;
                    this.$message({
                        message: res.data.msg,
                        type: 'error',
                        showClose: true,
                        duration: '1000'
                    });
                }
            });
        }
    },
    mounted() {
        if(location.search.includes('user_id')) {
            this.user_id = location.search.substring(9);
            this.autoLogin();
        }
    }
})